#ifndef CLOCK_H
#define CLOCK_H

#include <vector>

class Platform
{
public :
    static double GetSystemTime();

    static void Sleep(float time);
};

class Clock
{
public :
    Clock();

    float GetElapsedTime() const;

    void Reset();

private :
    double myStartTime; ///< Time of last reset
};

#endif

