#include "operation.h"
#include <sstream>
#include <iostream>

Operation::Operation(int level) :
	numbers(level + 1)
{
	srand(time(NULL));
	for(int i = 0; i < numbers; i++)
	{
		list_numbers.push_back(rand()%10);
		list_operators.push_back(rand()%3);
	}
	list_operators.pop_back();
	
	Calc();
}


Operation::~Operation()
{
}

void Operation::Calc()
{
	std::vector<int> nums;
	std::vector<int> oper;
	
	for (int i = 0; i < list_operators.size(); i++)
	{
		if (list_operators[i] == 2)
		{
			if (i != 0 && list_operators[i-1] == 2)
			{
				int last = nums[nums.size()-1];
				nums.pop_back();
				nums.push_back(last * list_numbers[i+1]);
			}
			else
			{
				nums.push_back(list_numbers[i] * list_numbers[i+1]);
			}
		}
		else
		{
			oper.push_back(list_operators[i]);
			
			if(i == 0 || list_operators[i-1] != 2)
			{
				nums.push_back(list_numbers[i]);
			}
			
			if (i+1 == list_operators.size())
			{
				nums.push_back(list_numbers[i+1]);
			}
		}
		
		result = nums[0];
		
		for (int i = 0; i < oper.size(); i++)
		{
			if (oper[i] == 0)
			{
				result += nums[i+1];
			}
			else
			{
				result -= nums[i+1];
			}
		}
	}
}

std::string Operation::GetString() const
{
	std::string str;
	for (int i = 0; i < list_numbers.size(); i++)
	{
		std::ostringstream out;
		out << list_numbers[i];
		str.append(out.str());
		if (list_operators.size() > i)
		{
			switch (list_operators[i])
			{
				case 0:
					str.append(" + ");
					break;
				case 1:
					str.append(" - ");
					break;
				case 2:
					str.append(" * ");
					break;
			}
		}
	}
	
	str.append(" = ");
	
	return str;
}
